image: docker:19.03.12
services:
  - docker:19.03.12-dind

stages:
  - build
  - test
  - release

variables:
  CONTAINER_TEST_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  CONTAINER_RELEASE_IMAGE: $CI_REGISTRY_IMAGE:latest

build:
  stage: build
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker build -t semantic-release /builds/LibreFoodPantry/training/spikeathons/summer-2021/deploy-theas-pantry/auto-versioning-test/semantic-release
    - docker tag semantic-release $CONTAINER_TEST_IMAGE
    - docker push $CONTAINER_TEST_IMAGE

commitlint:
  stage: test
  image: node:12
  allow_failure: true
  before_script:
    - npm install --save-dev @commitlint/{config-conventional,cli}
    - chmod +x commitconfig.sh
    - ./commitconfig.sh
  script:
    - npx commitlint --from=$CI_COMMIT_BEFORE_SHA

semantic-release:
  image: node:12-buster-slim
  stage: release
  before_script:
    - apt-get update && apt-get install -y --no-install-recommends git-core ca-certificates
    - npm install -g semantic-release @semantic-release/gitlab
    - npm install --save-dev @semantic-release/gitlab-config
  script:
    - semantic-release

release:
  stage: release
  rules:
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker pull $CONTAINER_TEST_IMAGE
    - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_IMAGE
    - docker push $CONTAINER_RELEASE_IMAGE